Kea: isc::dhcp::Dhcp4Parser::basic_symbol< Base > Struct Template Reference

| Kea 3.2.0-git

isc::dhcp::Dhcp4Parser::basic_symbol< Base > Struct Template Reference

A complete symbol. More...

`#include <dhcp4_parser.h>`

Inheritance diagram for isc::dhcp::Dhcp4Parser::basic_symbol< Base >:
[legend]

## Public Types
typedef Base | super_type
| Alias to Base.

## Public Member Functions
| basic_symbol () YY_NOEXCEPT
| Default constructor.
| basic_symbol (const basic_symbol &that)
| Copy constructor.
| basic_symbol (typename Base::kind_type t, const bool &v, const location_type &l)
| basic_symbol (typename Base::kind_type t, const double &v, const location_type &l)
| basic_symbol (typename Base::kind_type t, const ElementPtr &v, const location_type &l)
| basic_symbol (typename Base::kind_type t, const int64_t &v, const location_type &l)
| basic_symbol (typename Base::kind_type t, const location_type &l)
| Constructors for typed symbols.
| basic_symbol (typename Base::kind_type t, const std::string &v, const location_type &l)
| ~basic_symbol ()
| Destroy the symbol.
void | clear () YY_NOEXCEPT
| Destroy contents, and record that is empty.
bool | empty () const YY_NOEXCEPT
| Whether empty.
void | move (basic_symbol &s)
| Destructive move, s is emptied into this.
std::string | name () const YY_NOEXCEPT
| The user-facing name of this symbol.
symbol_kind_type | type_get () const YY_NOEXCEPT
| Backward compatibility (Bison 3.6).

## Public Attributes
location_type | location
| The location.
value_type | value
| The semantic value.

## Detailed Description

template<typename Base>
struct isc::dhcp::Dhcp4Parser::basic_symbol< Base >

A complete symbol.

Expects its Base type to provide access to the symbol kind via kind ().

Provide access to semantic value and location.

Definition at line 1502 of file dhcp4_parser.h.

## Member Typedef Documentation

## ◆ super_type

template<typename Base>

typedef Base isc::dhcp::Dhcp4Parser::basic_symbol< Base >::super_type

Alias to Base.

Definition at line 1505 of file dhcp4_parser.h.

## Constructor & Destructor Documentation

## ◆ basic_symbol() [1/8]

template<typename Base>

isc::dhcp::Dhcp4Parser::basic_symbol< Base >::basic_symbol | ( |  | ) |
| inline

Default constructor.

Definition at line 1508 of file dhcp4_parser.h.

Referenced by basic_symbol(), and move().

## ◆ basic_symbol() [2/8]

template<typename Base>

isc::dhcp::Dhcp4Parser::basic_symbol< Base >::basic_symbol | ( | const basic_symbol< Base > & | that | ) |

Copy constructor.

Definition at line 5926 of file dhcp4_parser.h.

References basic_symbol(), location, isc::dhcp::Dhcp4Parser::symbol_kind::S_auth_type_value, isc::dhcp::Dhcp4Parser::symbol_kind::S_BOOLEAN, isc::dhcp::Dhcp4Parser::symbol_kind::S_control_socket_type_value, isc::dhcp::Dhcp4Parser::symbol_kind::S_ddns_conflict_resolution_mode_value, isc::dhcp::Dhcp4Parser::symbol_kind::S_ddns_replace_client_name_value, isc::dhcp::Dhcp4Parser::symbol_kind::S_FLOAT, isc::dhcp::Dhcp4Parser::symbol_kind::S_INTEGER, isc::dhcp::Dhcp4Parser::symbol_kind::S_map_value, isc::dhcp::Dhcp4Parser::symbol_kind::S_ncr_protocol_value, isc::dhcp::Dhcp4Parser::symbol_kind::S_on_fail_mode, isc::dhcp::Dhcp4Parser::symbol_kind::S_outbound_interface_value, isc::dhcp::Dhcp4Parser::symbol_kind::S_socket_type, isc::dhcp::Dhcp4Parser::symbol_kind::S_ssl_mode, isc::dhcp::Dhcp4Parser::symbol_kind::S_STRING, isc::dhcp::Dhcp4Parser::symbol_kind::S_value, value, and YY_MOVE.

Here is the call graph for this function:

## ◆ basic_symbol() [3/8]

template<typename Base>

isc::dhcp::Dhcp4Parser::basic_symbol< Base >::basic_symbol | ( | typename Base::kind_type | t,
|  | const location_type & | l )
| inline

Constructors for typed symbols.

Definition at line 1569 of file dhcp4_parser.h.

## ◆ basic_symbol() [4/8]

template<typename Base>

isc::dhcp::Dhcp4Parser::basic_symbol< Base >::basic_symbol | ( | typename Base::kind_type | t,
|  | const ElementPtr & | v,
|  | const location_type & | l )
| inline

Definition at line 1582 of file dhcp4_parser.h.

## ◆ basic_symbol() [5/8]

template<typename Base>

isc::dhcp::Dhcp4Parser::basic_symbol< Base >::basic_symbol | ( | typename Base::kind_type | t,
|  | const bool & | v,
|  | const location_type & | l )
| inline

Definition at line 1596 of file dhcp4_parser.h.

## ◆ basic_symbol() [6/8]

template<typename Base>

isc::dhcp::Dhcp4Parser::basic_symbol< Base >::basic_symbol | ( | typename Base::kind_type | t,
|  | const double & | v,
|  | const location_type & | l )
| inline

Definition at line 1610 of file dhcp4_parser.h.

## ◆ basic_symbol() [7/8]

template<typename Base>

isc::dhcp::Dhcp4Parser::basic_symbol< Base >::basic_symbol | ( | typename Base::kind_type | t,
|  | const int64_t & | v,
|  | const location_type & | l )
| inline

Definition at line 1624 of file dhcp4_parser.h.

## ◆ basic_symbol() [8/8]

template<typename Base>

isc::dhcp::Dhcp4Parser::basic_symbol< Base >::basic_symbol | ( | typename Base::kind_type | t,
|  | const std::string & | v,
|  | const location_type & | l )
| inline

Definition at line 1638 of file dhcp4_parser.h.

## ◆ ~basic_symbol()

template<typename Base>

isc::dhcp::Dhcp4Parser::basic_symbol< Base >::~basic_symbol | ( |  | ) |
| inline

Destroy the symbol.

Definition at line 1646 of file dhcp4_parser.h.

## Member Function Documentation

## ◆ clear()

template<typename Base>

void isc::dhcp::Dhcp4Parser::basic_symbol< Base >::clear | ( |  | ) |
| inline

Destroy contents, and record that is empty.

Definition at line 1654 of file dhcp4_parser.h.

Referenced by isc::dhcp::Dhcp4Parser::parse().

## ◆ empty()

template<typename Base>

bool isc::dhcp::Dhcp4Parser::basic_symbol< Base >::empty | ( |  | ) | const

Whether empty.

Definition at line 5982 of file dhcp4_parser.h.

References isc::dhcp::Dhcp4Parser::symbol_kind::S_YYEMPTY, and YY_NOEXCEPT.

Referenced by isc::dhcp::Dhcp4Parser::parse().

## ◆ move()

template<typename Base>

void isc::dhcp::Dhcp4Parser::basic_symbol< Base >::move | ( | basic_symbol< Base > & | s | ) |

Destructive move, s is emptied into this.

Definition at line 5989 of file dhcp4_parser.h.

References basic_symbol(), location, isc::dhcp::Dhcp4Parser::symbol_kind::S_auth_type_value, isc::dhcp::Dhcp4Parser::symbol_kind::S_BOOLEAN, isc::dhcp::Dhcp4Parser::symbol_kind::S_control_socket_type_value, isc::dhcp::Dhcp4Parser::symbol_kind::S_ddns_conflict_resolution_mode_value, isc::dhcp::Dhcp4Parser::symbol_kind::S_ddns_replace_client_name_value, isc::dhcp::Dhcp4Parser::symbol_kind::S_FLOAT, isc::dhcp::Dhcp4Parser::symbol_kind::S_INTEGER, isc::dhcp::Dhcp4Parser::symbol_kind::S_map_value, isc::dhcp::Dhcp4Parser::symbol_kind::S_ncr_protocol_value, isc::dhcp::Dhcp4Parser::symbol_kind::S_on_fail_mode, isc::dhcp::Dhcp4Parser::symbol_kind::S_outbound_interface_value, isc::dhcp::Dhcp4Parser::symbol_kind::S_socket_type, isc::dhcp::Dhcp4Parser::symbol_kind::S_ssl_mode, isc::dhcp::Dhcp4Parser::symbol_kind::S_STRING, isc::dhcp::Dhcp4Parser::symbol_kind::S_value, value, and YY_MOVE.

Referenced by isc::dhcp::Dhcp4Parser::parse().

Here is the call graph for this function:

## ◆ name()

template<typename Base>

std::string isc::dhcp::Dhcp4Parser::basic_symbol< Base >::name | ( |  | ) | const
| inline

The user-facing name of this symbol.

Definition at line 1707 of file dhcp4_parser.h.

## ◆ type_get()

template<typename Base>

Dhcp4Parser::symbol_kind_type isc::dhcp::Dhcp4Parser::basic_symbol< Base >::type_get | ( |  | ) | const

Backward compatibility (Bison 3.6).

Definition at line 5974 of file dhcp4_parser.h.

References YY_NOEXCEPT.

## Member Data Documentation

## ◆ location

template<typename Base>

location_type isc::dhcp::Dhcp4Parser::basic_symbol< Base >::location

The location.

Definition at line 1725 of file dhcp4_parser.h.

Referenced by basic_symbol(), move(), and isc::dhcp::Dhcp4Parser::parse().

## ◆ value

template<typename Base>

value_type isc::dhcp::Dhcp4Parser::basic_symbol< Base >::value

The semantic value.

Definition at line 1722 of file dhcp4_parser.h.

Referenced by basic_symbol(), move(), and isc::dhcp::Dhcp4Parser::parse().

The documentation for this struct was generated from the following file:

- dhcp4_parser.h